Subject: Re: [netconf] more comments on netconf-adaptive-subscription revision -08

From: Qin Wu <[email-masked]>
Date: Mon, 7 Feb 2022 02:27:25 +0000

Thanks Michael for valuable review, see reply inline below.
-----邮件原件-----
发件人: netconf [mailto:[email-masked]] 代表 Michael Richardson
发送时间: 2022年1月31日 22:19
收件人: [email-masked]
主题: [netconf] more comments on netconf-adaptive-subscription revision -08

On 2021-06-24 15:14, Michael Richardson made some comments on:
> 
> I read:
>          Title           : Adaptive Subscription to YANG Notification
> 	Filename        : draft-wang-netconf-adaptive-subscription-05.txt
> 

I have reviewed a diff from -05 to -08, which you can see at:

https://www.ietf.org/rfcdiff?url1=draft-wang-netconf-adaptive-subscription-05&url2=draft-wang-netconf-adaptive-subscription-08

(I know that we have a new rfcdiff service being tested, but I can't recall where it is now)

I found the introduction of section 3, on XPath Evaluation is an interesting and welcome new addition.  I can't judge on the content of it, but it seems like it is useful things to explain.

[Qin] Yes, this piece was introduced based on comment raised by Rob in IETF 111 and IETF 112. The question is whether we select Arbitrary XPath and how complex such XPATH evaluation is. As we clarified in the section 3, we use similar selection filter defined in RFC8641 to express a standard XPATH Evaluation Criterion against targeted data object which has already defined in section 3.4 of RFC7950. In addition, we follow design rules defined in XPATH1.0, We are not using arbitrary XPATH evaluation, e.g, Support XPath Evaluation criteria against every data object, instead, we only support XPath Evaluation criteria against constant number. Therefore such xpath evaluation complexity is controllable.

leaf watermark {	
  	               type uint32;	
  	               description	
  	                 "The watermark for targeted data object. The higher	
  	                  or lower watermark can be specified for the	
  	                  targeted data object.";	
  	             }

probably this description should explain where the kind of watermark (high or low) is actually specified.
[Qin] Take thermostat module as example:
module thermostat {
…
leaf actual-temp {
type int32;
config false;
units “degrees Celsius”;
description “The measured temperature”;
}
}
We need to monitor the temperature change on specific function component in the device, We may need to control temperature change to make sure the highest temperature is not greater than high watermark and the lowest temperature is not less than Low watermark.
In addition, the watermark value is part of XPATH expression "xpath-external-eval", e.g., actual-temp<high-watermark&&atual-templ>low-watermark.
In this expression, high-watermark and low-watermark are both constant integer values. 
Since the watermark value is part of XPATH expression, therefore watermark parameter is an optional parameter, in some cases, it doesn't need.
Hope this clarifies.

I guess that I would never specify both, as that would be just two rules.
[Qin]: See our model design, we define a list of adaptive-periods, for each entry of adaptive periods, we will specify a watermark and corresponding xpath-external-eval.
Therefore we can specify both high watermark and low watermark using two entries. In other words, we can specify multiple rules in one subscprtion.

Are centiseconds already a typical unit for NETCONF?
[Qin]Yes, see similar example in yang push subscription model defined in RFC8641.

I see that you have rewritten the example YANG module for wifi based upon the CSA/MATTER data model.  It's good to have a realistic model.
I still wonder why an existing YANG model couldn't have been used.
[Qin]: CSA/MATTER only provide an information model, therefore we create a data model based on this information model defined in CSA/MATTER specification.
If CSA/MATTER data model has already been available somewhere, please let me know.

The text in section B.2 hints that the access point will change not just how often it reports, but how often it actually collects the data.
I'm not sure if that is the intention?
[Qin]: Yes, you are right, the goal is to focus on how often it reports, we can make this clear in the next version.
I think when it says "server", I think you mean access point?
[Qin]Yes, the access point will collect the data and report back to Wireless Lan access controller (Known as AC)[Qin Wu] .

_______________________________________________
netconf mailing list
[email-masked]
https://www.ietf.org/mailman/listinfo/netconf